import { NodeData } from '../types';
export declare function measureText(text: string): {
    height: number;
    width: number;
};
export declare function parsePadding(padding: NodeData['nodePadding']): {
    top: number;
    right: number;
    bottom: number;
    left: number;
};
export declare function formatText(node: NodeData): {
    text: any;
    originalText: any;
    width: number;
    height: number;
    nodePadding: {
        top: number;
        right: number;
        bottom: number;
        left: number;
    };
    labelHeight: number;
    labelWidth: number;
};
